<?php
/**
 * 为你的Typecho装备酷爽flash MP3播放器Audio Player
 * 
 * @package AudioPlayer
 * @author 羽中
 * @version 1.1.0
 * @link http://zhengyuzhong.com
 */
class AudioPlayer_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate(){
        Typecho_Plugin::factory('Widget_Abstract_Contents')->excerptEx = array('AudioPlayer_Plugin', 'parse');
        Typecho_Plugin::factory('Widget_Abstract_Contents')->contentEx = array('AudioPlayer_Plugin', 'parse');
    }
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}
    
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
public static function config(Typecho_Widget_Helper_Form $form){
    	$gifUrl = Typecho_Common::url('AudioPlayer/apmap.png', Helper::options()->pluginUrl);
	    echo "<div style='height:124px;font-size:13px;margin:2px auto;padding:5px;border:solid #ccc 1px;background:#EDF0DF;'><div style='float:left;'><img src='$gifUrl' alt='颜色设置示例' title='颜色设置示例' width='390' height='124' /></div><div style='padding:10px;float:right;overflow:hidden;'><strong>说明：</strong><br/>可视或代码编辑模式下均可使用<span style='color:blue;'>[mp3]</span>http://xx.mp3<span style='color:blue;'>[/mp3]</span>格式添加播放器<br/>多个mp3地址可用<span style='color:blue;font-size:16px;font-weight:bold;'>,</span>号隔开，播放器会自动识别为排序播放模式<br/><br/><p style='text-align:right;font-size:13px'>如有其他使用问题可以<a href='' target='_blank'>给我留言</a>:)</p></div></div><div style='clear:both'></div>";
	    $behaviour = new Typecho_Widget_Helper_Form_Element_Checkbox('behaviour',
     	array('links'=>'自动将文章中的mp3文件链接替换为播放器（可能会影响文章排版）'),NULL,'开启自动替换功能',NULL);
        $form->addInput($behaviour->setAttribute('style', 'margin-bottom:-19px;')); 
	    $dcolor = new Typecho_Widget_Helper_Form_Element_Checkbox('dcolor',
     	array('default'=>'使用缺省的黑灰色风格（勾选后自定义颜色设置无效）'),NULL,'使用缺省颜色风格','<p style="font-size:13px;margin:20px 0 -2px;">以下为<strong>自定义颜色设置</strong>，请输入6位颜色代码（注意<span style="color:red;font-weight:bold;">不需要#号</span>）</p>');
        $form->addInput($dcolor);
	    $bg = new Typecho_Widget_Helper_Form_Element_Text('bg',NULL,'CDDFF3','底色',NULL);
        $form->addInput($bg->setAttribute('style', 'margin:-18px 0 -22px;'));
        $leftbg = new Typecho_Widget_Helper_Form_Element_Text('leftbg',NULL,'357DCE','左部底色',NULL);
        $form->addInput($leftbg->setAttribute('style', 'margin:-22px 0;'));
        $lefticon = new Typecho_Widget_Helper_Form_Element_Text('lefticon',NULL,'F2F2F2','左部图标色',NULL);
        $form->addInput($lefticon->setAttribute('style', 'margin:-22px 0;'));
	    $voltrack = new Typecho_Widget_Helper_Form_Element_Text('voltrack',NULL,'8EC2F4','音量底色',NULL);
        $form->addInput($voltrack->setAttribute('style', 'margin:-22px 0;'));
        $volslider = new Typecho_Widget_Helper_Form_Element_Text('volslider',NULL,'F2F2F2','音量滑块',NULL);
        $form->addInput($volslider->setAttribute('style', 'margin:-22px 0;'));
        $rightbg = new Typecho_Widget_Helper_Form_Element_Text('rightbg',NULL,'357DCE','右部底色',NULL);
        $form->addInput($rightbg->setAttribute('style', 'margin:-22px 0;'));    
        $rightbghover = new Typecho_Widget_Helper_Form_Element_Text('rightbghover',NULL,'4499EE','右部底鼠标变色',NULL);
        $form->addInput($rightbghover->setAttribute('style', 'margin:-22px 0;'));
        $righticon = new Typecho_Widget_Helper_Form_Element_Text('righticon',NULL,'F2F2F2','右部图标色',NULL);
        $form->addInput($righticon->setAttribute('style', 'margin:-22px 0;'));
        $righticonhover = new Typecho_Widget_Helper_Form_Element_Text('righticonhover',NULL,'FFFFFF','右部图标鼠标变色',NULL);
        $form->addInput($righticonhover);
        $text = new Typecho_Widget_Helper_Form_Element_Text('text',NULL,'357DCE','文字',NULL);
        $form->addInput($text->setAttribute('style', 'margin:-22px 0;'));
        $tracker = new Typecho_Widget_Helper_Form_Element_Text('tracker',NULL,'CDDFF3','进度条',NULL);
        $form->addInput($tracker->setAttribute('style', 'margin:-22px 0;'));
        $track = new Typecho_Widget_Helper_Form_Element_Text('track',NULL,'F2F2F2','进度条轨道',NULL);
        $form->addInput($track->setAttribute('style', 'margin:-22px 0;'));
        $border = new Typecho_Widget_Helper_Form_Element_Text('border',NULL,'FFFFFF','进度条边界',NULL);
        $form->addInput($border->setAttribute('style', 'margin:-22px 0;'));
        $loader = new Typecho_Widget_Helper_Form_Element_Text('loader',NULL,'8EC2F4','加载条',NULL);
        $form->addInput($loader->setAttribute('style', 'margin:-22px 0;'));
        $skip = new Typecho_Widget_Helper_Form_Element_Text('skip',NULL,'4499EE','切歌按钮',NULL);
        $form->addInput($skip->setAttribute('style', 'margin:-22px 0;'));
		$loop = new Typecho_Widget_Helper_Form_Element_Radio('loop', array('yes' => '是', 'no' => '否'), 'no', '循环播放','<p style="font-size:13px;margin-top:15px;"><strong>自动播放</strong>模式可在mp3地址后直接添加<span style="color:blue;">&autostart=yes</span>开启，在此不做统一设置。<br/>例：[mp3]http://xx.mp3&autostart=yes[/mp3]</p>');
		$form->addInput($loop->setAttribute('style', 'margin:10px 0 0;'));
 }
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 插件实现方法
     * 
     * @access public
     * @return void
     */
     
    public static function parse($text = '', $widget, $lastResult)
    {
        $text = empty($lastResult) ? $text : $lastResult;
        $settings = Helper::options()->plugin('AudioPlayer');
        $swfUrl = Typecho_Common::url('AudioPlayer/audioplayer.swf', Helper::options()->pluginUrl);
        $func_list = array('default','links');
        if($func_list['default'] = $settings->dcolor) {$replace = "<object type=\"application/x-shockwave-flash\" data=\"{$swfUrl}\" width=\"290\" height=\"24\">
<param name=\"movie\" value=\"{$swfUrl}\" />
  <param name=\"flashvars\" value=\"soundFile=\\2\" />
  <param name=\"wmode\" value=\"transparent\" />
</object>";}
        else {$replace = "<object type=\"application/x-shockwave-flash\" data=\"{$swfUrl}\" width=\"290\" height=\"24\">
<param name=\"movie\" value=\"{$swfUrl}\" />
  <param name=\"flashvars\" value=\"soundFile=\\2&bg=0x{$settings->bg}&leftbg=0x{$settings->leftbg}&lefticon=0x{$settings->lefticon}&voltrack=0x{$settings->voltrack}&volslider=0x{$settings->volslider}&rightbg=0x{$settings->rightbg}&rightbghover=0x{$settings->rightbghover}&righticon=0x{$settings->righticon}&righticonhover=0x{$settings->righticonhover}&text=0x{$settings->text}&tracker=0x{$settings->tracker}&track=0x{$settings->track}&border=0x{$settings->border}&loader=0x{$settings->loader}&skip=0x{$settings->skip}\" />
  <param name=\"wmode\" value=\"transparent\" />
</object>";}
        if ($widget instanceof Widget_Archive) {
            if($func_list['links'] = $settings->behaviour) {$text = preg_replace("/<a ([^=]+=\"[^\"]+\" )*href=\"([^\"]+\.mp3)\"( [^=]+=\"[^\"]+\")*>[^<]+<\/a>/i",$replace,$text);}
            $text = preg_replace("/\[(mp3)](.*?)\[\/\\1]/is",$replace,$text);
        }
        return $text;
    }
}
